var ApiResponse = (function () {
    function ApiResponse(service, response) {
        this.service = service;
        this.response = response;
    }
    ApiResponse.prototype.transform = function (data) {
        var transformer = this.service.transformer();
        return transformer.call(data);
    };
    ApiResponse.prototype.fetch = function () {
        return this.transform(this.getResponse());
    };
    ApiResponse.prototype.getPagination = function () {
        return this.getMeta().pagination;
    };
    ApiResponse.prototype.getLinks = function () {
        return this.getResponse().links;
    };
    ApiResponse.prototype.getIncluded = function () {
        return this.getResponse().included;
    };
    ApiResponse.prototype.getMeta = function () {
        return this.getResponse().meta;
    };
    ApiResponse.prototype.getData = function () {
        return this.getResponse().data;
    };
    ApiResponse.prototype.getResponse = function () {
        return this.response;
    };
    return ApiResponse;
}());
export { ApiResponse };
//# sourceMappingURL=api-response.js.map