var Collection = (function () {
    function Collection(items) {
        if (items === void 0) { items = []; }
        this.items = items;
    }
    Collection.prototype.add = function (item) {
        if (item instanceof Array)
            return (_a = this.items).push.apply(_a, item);
        else
            return this.items.push(item);
        var _a;
    };
    Collection.prototype.remove = function (item) {
        if (item instanceof Number)
            return this.items.splice(item, 1);
        else {
            var index = this.items.indexOf(item);
            if (index !== -1)
                return this.items.splice(index, 1);
            else
                return this.items;
        }
    };
    Collection.prototype.get = function (index) {
        return this.items[index];
    };
    Collection.prototype.all = function () {
        return this.items;
    };
    Collection.prototype.first = function () {
        return this.items[0];
    };
    Collection.prototype.last = function () {
        return this.items[this.items.length - 1];
    };
    Collection.prototype.count = function () {
        return this.items.length;
    };
    Collection.prototype.has = function (item) {
        if (item instanceof Number)
            return item in this.items;
        else
            return this.items.indexOf(item) >= 0;
    };
    return Collection;
}());
export { Collection };
//# sourceMappingURL=collection.js.map