import { RequestOptionsArgs, Response } from "@angular/http";
import { ApiResponse } from "./api-response";
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/catch';
import 'rxjs/add/operator/map';
import { ITransformer } from "./itransformer";
import { Search } from "./search";
import { Order } from "./order";
import { Filter } from "./filter";
import { Relation } from "./relation";
import { IEntity } from "./ientity";
export interface IApiService<Model extends IEntity> {
    transformer(): ITransformer<Model>;
    get(url: string, search?: Search[], orders?: Order[], filters?: Filter[], relations?: Relation[], options?: RequestOptionsArgs): Observable<ApiResponse<Model>>;
    post(url: string, body: Model | any, options?: RequestOptionsArgs): Observable<ApiResponse<Model>>;
    put(url: string, body: Model | any, options?: RequestOptionsArgs): Observable<ApiResponse<Model>>;
    patch(url: string, body: Model | any, options?: RequestOptionsArgs): Observable<ApiResponse<Model>>;
    delete(url: string, options?: RequestOptionsArgs): Observable<ApiResponse<Model>>;
    head(url: string, options?: RequestOptionsArgs): Observable<Response>;
    options(url: string, options?: RequestOptionsArgs): Observable<Response>;
}
