var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Factory } from "./factory";
import { Order } from "./order";
import { OrderCollection } from "./order.collection";
import { SortCollection } from "./sort.collection";
var OrderFactory = (function (_super) {
    __extends(OrderFactory, _super);
    function OrderFactory(order) {
        var _this = _super.call(this) || this;
        if (!(order instanceof Order || order instanceof Array))
            throw new TypeError('Order argument must be a type "Order" or "Order[]".');
        if (!(order instanceof Array))
            _this.order = [order];
        else
            _this.order = order;
        return _this;
    }
    OrderFactory.prototype.create = function (type) {
        switch (type) {
            case OrderFactory.TYPE_QUERY:
                return new OrderCollection(this.order);
            case OrderFactory.TYPE_FIELDS:
                return new SortCollection(this.order);
            default:
                throw new Error('Order factory support only: "query" or "fields" type.');
        }
    };
    return OrderFactory;
}(Factory));
export { OrderFactory };
//# sourceMappingURL=order.factory.js.map