var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Search } from "./search";
import { Factory } from "./factory";
import { SearchCollection } from "./search.collection";
import { SearchFieldCollection } from "./search-field.collection";
var SearchFactory = (function (_super) {
    __extends(SearchFactory, _super);
    function SearchFactory(search) {
        var _this = _super.call(this) || this;
        if (!(search instanceof Search || search instanceof Array))
            throw new TypeError('Search argument must be a type "Search" or "Search[]".');
        if (!(search instanceof Array))
            _this.search = [search];
        else
            _this.search = search;
        return _this;
    }
    SearchFactory.prototype.create = function (type) {
        switch (type) {
            case SearchFactory.TYPE_QUERY:
                return new SearchCollection(this.search);
            case SearchFactory.TYPE_FIELDS:
                return new SearchFieldCollection(this.search);
            default:
                throw new Error('Search factory support only: "query" or "fields" type.');
        }
    };
    return SearchFactory;
}(Factory));
export { SearchFactory };
//# sourceMappingURL=search.factory.js.map