import { InjectionToken, Injector } from "@angular/core";
import { ITransformer } from "./itransformer";
import { IEntity } from "./ientity";
import { ITransformerDataMap, ITransformerDataMapEntry } from "./itransformer-data.map";
import { ITransformerMap } from "./itransformer.map";
export declare const TRANSFORMERS_DATA_MAP: ITransformerDataMap;
export declare class TransformerMap implements ITransformerMap {
    private injector;
    private static map;
    constructor(injector: Injector);
    /**
     * Put the transformer entry to map.
     *
     * @param key
     * @param entry
     */
    put(key: string, entry: ITransformerDataMapEntry): void;
    /**
     * Put token and transformer class to map.
     * @param key
     * @param token
     * @param transformerClass
     */
    put(key: string, token: InjectionToken<ITransformer<IEntity>>, transformerClass?: new (transformersMap: ITransformerMap) => ITransformer<IEntity>): void;
    /**
     * Create transformer map entry.
     *
     * @param token Injection token.
     * @param transformerClass Transformer class.
     * @returns {ITransformerDataMapEntry}
     */
    private static createEntry(token, transformerClass?);
    /**
     * Inject and get the transformer instance by key.
     *
     * @param key
     * @returns {ITransformer<IEntity>}
     */
    get(key: string): ITransformer<IEntity>;
}
export declare const TRANSFORMERS_MAP: InjectionToken<ITransformerMap>;
