var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Injectable, InjectionToken } from "@angular/core";
export var TRANSFORMERS_DATA_MAP = {};
var TransformerMap = (function () {
    function TransformerMap(injector) {
        this.injector = injector;
    }
    TransformerMap_1 = TransformerMap;
    /**
     * Put the transformer entry to map.
     *
     * @param args
     */
    TransformerMap.prototype.put = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var key = args[0];
        var entryToken = args[1];
        var transformerClass = args[2];
        var entry;
        if (entryToken instanceof InjectionToken)
            entry = TransformerMap_1.createEntry(entryToken, transformerClass);
        else
            entry = entryToken;
        TransformerMap_1.map[key] = entry;
    };
    /**
     * Create transformer map entry.
     *
     * @param token Injection token.
     * @param transformerClass Transformer class.
     * @returns {ITransformerDataMapEntry}
     */
    TransformerMap.createEntry = function (token, transformerClass) {
        return {
            token: token,
            transformerClass: transformerClass
        };
    };
    /**
     * Inject and get the transformer instance by key.
     *
     * @param key
     * @returns {ITransformer<IEntity>}
     */
    TransformerMap.prototype.get = function (key) {
        try {
            return this.injector.get(TransformerMap_1.map[key].token);
        }
        catch (e) {
            throw new Error("Can't inject transformer by key \"" + key + "\". Maybe transformer not registered in the map.");
        }
    };
    TransformerMap.map = TRANSFORMERS_DATA_MAP;
    TransformerMap = TransformerMap_1 = __decorate([
        Injectable()
    ], TransformerMap);
    return TransformerMap;
    var TransformerMap_1;
}());
export { TransformerMap };
export var TRANSFORMERS_MAP = new InjectionToken('app.transformers-map');
//# sourceMappingURL=transformer-map.service.js.map