import {IFactory} from "./ifactory";
import {Aliases} from "./aliases";
import {AliasMap} from "./alias.map";

export class AliasMapFactory implements IFactory<AliasMap> {
    constructor(private aliases: Aliases) {}

    public create(): AliasMap {
        const map: AliasMap = new Map();
        const keys: string[] = Object.getOwnPropertyNames(this.aliases);

        for (let key of keys)
            map.set(key, this.aliases[key]);

        return map;
    }
}