import {ICollection} from "./icollection";

export abstract class Collection<T> implements ICollection<T>
{
    constructor(private items: T[] = []) {}

    public add(item: T): number;
    public add(item: T[]): number;
    public add(item: any): number {
        if (item instanceof Array)
            return this.items.push(...item);
        else
            return this.items.push(item);
    }

    public remove(index: number): T[];
    public remove(item: T): T[];
    public remove(item: any): T[] {
        if (item instanceof Number)
            return this.items.splice(<number>item, 1);
        else {
            let index: number = this.items.indexOf(item);
            if (index !== -1)
                return this.items.splice(index, 1);
            else
                return this.items;
        }
    }

    public get(index: number): T {
        return this.items[index];
    }

    public all(): T[] {
        return this.items;
    }

    public first(): T {
        return this.items[0];
    }

    public last(): T {
        return this.items[this.items.length - 1];
    }

    public count(): number {
        return this.items.length;
    }

    public has(item: T): boolean
    public has(item: number): boolean;
    public has(item: any): boolean {
        if (item instanceof Number)
            return <number>item in this.items;
        else
            return this.items.indexOf(item) >= 0;
    }
}