import {Factory} from "./factory";
import {ApiCollection} from "./api.collection";
import {Filter} from "./filter";
import {Search} from "./search";
import {FilterCollection} from "./filter.collection";

export class FilterFactory extends Factory<ApiCollection<Filter>> {
    private filters: Filter[];

    constructor(filters: Filter);
    constructor(filters: Filter[]);
    constructor(filters: any) {
        super();

        if (!(filters instanceof Search || filters instanceof Array))
            throw new TypeError('Search argument must be a type "Search" or "Search[]".');

        if (!(filters instanceof Array))
            filters = [filters];

        this.filters = filters;
    }

    public create(type: string): ApiCollection<Filter> {
        switch (type) {
            case FilterFactory.TYPE_FIELDS:
                return new FilterCollection(this.filters);
            default:
                throw new Error('Filter factory support only: "fields" type.');
        }
    }
}