import {ApiCollection} from "./api.collection";
import {Order} from "./order";

export class OrderCollection extends ApiCollection<Order> {
    public static readonly separator: string = ';';

    public toUrl(): string {
        return this.all()
            .map((item: Order) => {
                if (item.table && item.customKey && item.field)
                    return `${item.table}:${item.customKey}|${item.field}`;
                else if (item.table && item.field)
                    return `${item.table}|${item.field}`;
                else
                    return item.field;
            })
            .join(OrderCollection.separator);
    }
}