import {ApiCollection} from "./api.collection";
import {Search} from "./search";

export class SearchFieldCollection extends ApiCollection<Search> {
    public static readonly separator: string = ';';
    public static readonly defaultOperator: string = '=';

    public toUrl(): string {
        return this.all()
            .map((item: Search) => {
                return item.operator !== SearchFieldCollection.defaultOperator ? `${item.field}:${item.operator}` : null
            })
            .filter((item) => {
                return item
            })
            .join(SearchFieldCollection.separator);
    }
}