import {ApiCollection} from "./api.collection";
import {Order, Sort} from "./order";

export class SortCollection extends ApiCollection<Order> {
    public static readonly separator: string = ';';
    public static readonly defaultSort = Sort.ASC;

    public toUrl(): string {
        return this.all()
            .map((item: Order) => {
                return item.sort != SortCollection.defaultSort ? `${item.field}:${item.sort == Sort.DESC ? 'desc' : 'asc'}` : null
            })
            .join(SortCollection.separator);
    }
}